#include <bits/stdc++.h>

using namespace std;

int t, n, m;
long long a[75005], b[75005], x, x1, x2, y;

int main(){
cin>>t;
for(int u=1; u<=t; u++){
cin>>n>>m;
    for(int i=1; i<=n; i++){
        cin>>a[i];
    }
    for(int i=1; i<=m; i++){
        cin>>b[i];
    }
        x1=min(a[1], a[2]);
        x2=max(a[1], a[2]);
        x=x2-x1;
            for(int i=1; i<=m; i++){
                if((b[i]-b[i-1])%x==0){
                    cout<<1<<endl;
                    break;
                }
                else if(i==m){cout<<0<<endl;}
            }
}
return 0;}